#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <File.h>
#include <fs_attr.h>

#include "BF_Roster.h"
#include "BF_Msg.h"
#include "BF_GUI_Func.h"
#include "BF_GUI_Tools.h"
#include "BF_GUI_FilePanel.h"
#include "BF_GUI_KeysMenu.h"
 
/*=====================================================================*/
/* select volume													   */
/*=====================================================================*/ 
   
void
BF_GUI_FilePanel::Action_SelVolume_0(BF_Panel_Pos i_WinPos)
{
	/* disable panels */
	BF_GUI_Func_PanelsEnable(false);
	/* prepare volume_list */
	BL_List loNodeVol;
	BF_Roster_VolumeList(loNodeVol,	
		BF_ROSTER_LOADVOLS_SPEC |
		( (poSysSetup->iMainStyle & BF_SETUP_MAIN_SELECTVOL_SPECFIRST)?BF_ROSTER_LOADVOLS_SPEC_FIRST:0 ) |
		( (poSysSetup->iMainStyle & BF_SETUP_MAIN_SELECTVOL_SHOWSICON)?BF_ROSTER_LOADVOLS_SICON:0 )		
	);	
	BL_List *ploMenu = new BL_List();
	BF_GUI_ViewMenu_Item *po;
	BF_Node *poNode;
	
	for(int i=0;i<loNodeVol.CountItems();i++){
		poNode = (BF_Node*)loNodeVol.ItemAt(i);
		///
		po = new BF_GUI_ViewMenu_Item(poNode->sName.String(),poNode->sName.String() );
		ploMenu->AddItem(po);
		if(poNode->poSIcon && (poSysSetup->iMainStyle & BF_SETUP_MAIN_SELECTVOL_SHOWSICON))	po->poSIcon = new BBitmap( poNode->poSIcon );
	}		
	/* prepare message for dialog */
	BMessage oMessage(BF_MSG_FILEPANEL_VOL_SELECTED);		
	BView *poTarget=NULL;	
	if(i_WinPos==iWinPosition)
		poTarget = this;
	else
		poTarget = poFriend;
	oMessage.AddPointer("bf_focus",(void*)poTarget);
	oMessage.AddPointer("bf_panel_focus",(void*)this);
	//oMessage.AddPointer("bf_panel",(void*)poTarget);
	/* calc max_item  width */
	float fMaxWidth=0;
	{
		BF_GUI_ViewMenu_Item *po;
		float f;
		for(int i=0;i<ploMenu->CountItems();i++){
			po = (BF_GUI_ViewMenu_Item*)ploMenu->ItemAt(i);			
			ASSERT(po);
			f = poSysSetup->oFontToolView.oFont.StringWidth(po->sTitle.String());
			if(f>fMaxWidth) fMaxWidth = f;
		}
		if((poSysSetup->iMainStyle & BF_SETUP_MAIN_SELECTVOL_SHOWSICON)) fMaxWidth+=19;
	}	
	/* prepare rect for dialog */
	BRect oRect(30,30,0,0);
	if(i_WinPos!=BF_PANEL_WINPOS_LEFT) oRect.left+=fWidth;	
	oRect.right = oRect.left + fMaxWidth + 	SIZE_SHADOW_X + SIZE_FRAME*2 + SIZE_SPACE*2;						
	oRect.bottom = oRect.top+ SIZE_SHADOW_Y + SIZE_FRAME*2 + SIZE_SPACE*2;
	float fHeight = poSysSetup->oFontToolView.fHeight;
	if((poSysSetup->iMainStyle & BF_SETUP_MAIN_SELECTVOL_SHOWSICON) && fHeight<18) fHeight = 18;
		oRect.bottom+=(ploMenu->CountItems())*fHeight;
	/* make dialog */	
	BF_GUI_Dialog *poDialog = new BF_GUI_Dialog(oRect,"Select Volume","dialog",&oMessage,
		(BF_PANEL_WINPOS_RIGHT==i_WinPos)?BG_GUI_DIALOG_WINRESIZE_NONE:BG_GUI_DIALOG_WINRESIZE_MOVE_RCENTER);
	/* make menu */
	poDialog->LocalBounds(oRect);
	BView * poMenu = new BF_GUI_ViewVMenu(oRect,"menu",	B_FOLLOW_ALL,ploMenu,
		(poSysSetup->iMainStyle & BF_SETUP_MAIN_SELECTVOL_SHOWSICON)?BF_GUI_VIEWVMENU_SICON:0);
	poDialog->AddChild(poMenu);
	/* finish */
	poWinView->AddChild(poDialog );	
	/* */	
	return;

}

void
BF_GUI_FilePanel::Action_SelVolume_1(BMessage *po_Message)
{
	bool bOk;
	ASSERT(B_OK==po_Message->FindBool(BF_GUI_DIALOG_MESSAGE_DATA_OK,&bOk));
	/* get focus panel */
	BF_GUI_FilePanel *poFocusPanel;				
	ASSERT(B_OK==po_Message->FindPointer("bf_panel_focus",(void**)&poFocusPanel));
	/* activate panel */
	BF_GUI_Func_PanelsEnable(true);	
	poFocusPanel->MakeFocus();
	/* change path */
	if(bOk){
		{
			char 	*pc;	
			if(B_OK!=po_Message->FindString("menu_code",(const char**)&pc))	return;
			BString s;
			s = "/";
			s << pc;
			CashNode_Clear();
			BF_Path oNewPath(s.String());
			NavGoPath(oNewPath);
		}
	}	
}

/*=====================================================================*/
/* select files														   */
/*=====================================================================*/

bool
BF_GUI_FilePanel::NavSelectAll_0(char c_Key)
{
	BMessage oMessage(BF_MSG_INPUTMASK);
	oMessage.AddPointer("bf_focus",this);
	//
	BString sTitle;
	switch(c_Key){
	case '*' :	sTitle="Invert selection";break;	
	case '+' :	sTitle="Set selection";break;		
	case '-' :	sTitle="Unset selection";break;			
	};
	oMessage.AddInt8("bf_cKey",c_Key);		
	/* */
	BF_GUI_Func_PanelsEnable(false);
	/* make dialog */	
	BF_GUI_Dialog *poDialog = new BF_GUI_Dialog(BRect(30,30,300,120),
		sTitle.String(),"dialog",&oMessage,BG_GUI_DIALOG_WINRESIZE_MOVE_CENTER);
	poDialog->MoveToCenter( poWinView );	
	BRect oRect;	
	/* insert edit */
	poDialog->LocalBounds(oRect);	
	oRect.bottom = oRect.top+poSysSetup->oFontToolView.fHeight;
	BF_GUI_ViewEdit *poEdit = new BF_GUI_ViewEdit(oRect,"edit",
					sNodeSelMask.String(),
					B_FOLLOW_LEFT_RIGHT|B_FOLLOW_TOP,B_NAVIGABLE);
	poDialog->AddChild(poEdit);
	/* insert check */
	oRect.top = oRect.bottom+5;
	oRect.bottom = oRect.top + poSysSetup->oFontToolView.fHeight;
	BF_GUI_ViewCheck *poCheck = new BF_GUI_ViewCheck(oRect,"dir_also",
					"folders",bSelectDirAlso,
					B_FOLLOW_LEFT_RIGHT|B_FOLLOW_TOP,B_NAVIGABLE);
	poDialog->AddChild(poCheck);
	/* finish */
	poWinView->AddChild( poDialog );	
	/* */		
	return true;
}

void
BF_GUI_FilePanel::NavSelectAll_1(BMessage *po_Message)
{	
	bool	bOk;
	ASSERT(B_OK==po_Message->FindBool(BF_GUI_DIALOG_MESSAGE_DATA_OK,&bOk));
	if(bOk){
		char 	*pcEditResult;
		ASSERT(B_OK==po_Message->FindString("edit",(const char**)&pcEditResult));
		ASSERT(B_OK==po_Message->FindBool("dir_also",&bSelectDirAlso));
		/* prep  */
		uint32 iWhatSelect = 0;
		iWhatSelect=iWhatSelect | BF_NODELIST_NODETYPE_FILES;
		iWhatSelect=iWhatSelect | BF_NODELIST_NODETYPE_LINKS;
		if(bSelectDirAlso)
		iWhatSelect=iWhatSelect | BF_NODELIST_NODETYPE_DIRS;
		/* */
		char cKey;		
		ASSERT(B_OK==po_Message->FindInt8("bf_cKey",(int8*)&cKey));
		switch(cKey){
		case '*' :
			loNode.SetSelectAll(BF_NODE_SELECT_INVERT,pcEditResult,iWhatSelect);break;
		case '+':
			loNode.SetSelectAll(BF_NODE_SELECT_ON,pcEditResult,iWhatSelect);break;
		case '-':
			loNode.SetSelectAll(BF_NODE_SELECT_OFF,pcEditResult,iWhatSelect);break;			
		}
		sNodeSelMask = pcEditResult;
		
		DrawNodes(true);
		DrawSelListInfo(true);
	}
	//
	BF_GUI_Func_PanelsEnable(true);
	MakeFocus();
}


/*=====================================================================*/
/* make new dir														   */
/*=====================================================================*/

void
BF_GUI_FilePanel::Action_MakeDir_0()
{
	/* check for "/" path */
	if(oPath.IsVirtualRoot()){
		BF_Dialog_Alert_Sep("Warning","Sorry, but is a virtual root and it`s a wrong place",NULL,this," for such operation");
		return;
	}
	/* disable panels */
	BF_GUI_Func_PanelsEnable(false);
	//
	BMessage oMessage(BF_MSG_MAKEDIR);
	oMessage.AddPointer("bf_focus",this);
	//
	/* make dialog */	
	BF_GUI_Dialog *poDialog = new BF_GUI_Dialog(BRect(30,30,300,100),
		"Make Dir","dialog",&oMessage,BG_GUI_DIALOG_WINRESIZE_MOVE_CENTER);
	poDialog->MoveToCenter( poWinView );	
	BRect oRect;	
	/* insert edit */
	poDialog->LocalBounds(oRect);	
	oRect.bottom = oRect.top+poSysSetup->oFontToolView.fHeight;
	BF_GUI_ViewEdit *poEdit = new BF_GUI_ViewEdit(oRect,"edit",
					"",
					B_FOLLOW_LEFT_RIGHT|B_FOLLOW_TOP,B_NAVIGABLE);
	poDialog->AddChild(poEdit);	
	/* finish */
	poWinView->AddChild(poDialog );	
	/* */	
}

void
BF_GUI_FilePanel::Action_MakeDir_1(BMessage *po_Message)
{
	//
	char *pcValue=NULL;
	bool bOk;
	ASSERT(B_OK==po_Message->FindBool(BF_GUI_DIALOG_MESSAGE_DATA_OK,&bOk));
	if(bOk && B_OK==po_Message->FindString("edit",(const char**)&pcValue) && pcValue){		
		BF_Node *poNode = loNode.NodeByName(pcValue);
		if(!poNode){
			BString s(oPath.Path());
			s<<"/";
			s<<pcValue;
			BF_Roster_MakeDir(s.String());		
			loNodeEvent.NewEvent(pcValue,BF_NODE_EVENT_SETCURSOR);
		}else{
			int iNewIndex = loNode.IndexOf(poNode);			
			NavChangeCursor(iNewIndex);			
		}
	}				
	//
	/* enable panels */
	BF_GUI_Func_PanelsEnable(true);
	MakeFocus();
}

/*=====================================================================*/
/* make links 														   */
/*=====================================================================*/

int32 
BF_GUI_FilePanel_MakeLinkThread(void *data);

void
BF_GUI_FilePanel::Action_MakeLink_0()
{
	/* disable panels */
	BF_GUI_Func_PanelsEnable(false);
	/* make message for dialog */
	BMessage oMessage(BF_MSG_MAKELINK);
	oMessage.AddPointer("bf_focus",this);
	/* make dialog */	
	float fWidth = poWinView->Bounds().Width();
	if(fWidth<400) fWidth-=40;else fWidth=400;
	BF_GUI_Dialog *poDialog = new BF_GUI_Dialog(BRect(30,30,fWidth,120),
		"Make link(s)","dialog",&oMessage,BG_GUI_DIALOG_WINRESIZE_MOVE_CENTER);
	poDialog->MoveToCenter( poWinView );	
	/* insert views */
	BRect oRect;
	/* insert text */
	poDialog->LocalBounds(oRect);
	oRect.top+=10;
	oRect.bottom = oRect.top+poSysSetup->oFontToolView.fHeight*2+4;
	poDialog->AddChild(new BF_GUI_ViewText(oRect,"text","Make link(s) in another panel?",
			B_FOLLOW_NONE,B_WILL_DRAW));	
	/* prepare items for menu */
	BL_List *ploMenu = new BL_List();
	ploMenu->AddItem(new BF_GUI_ViewMenu_Item("Ok","ok"));
	ploMenu->AddItem(new BF_GUI_ViewMenu_Item("Cancel","cancel"));
	/* insert menu */	
	poDialog->LocalBounds(oRect);
	oRect.bottom-=5;
	oRect.top=oRect.bottom - poSysSetup->oFontToolView.fHeight+2;
	oRect.left+=10;
	oRect.right-=10;			
	BF_GUI_ViewHMenu *poMenu = new BF_GUI_ViewHMenu(oRect,"menu",B_FOLLOW_BOTTOM,
		ploMenu);	
	poDialog->AddChild(poMenu);
	/* finish */
	poWinView->AddChild(poDialog );	
	/* */	
}

void
BF_GUI_FilePanel::Action_MakeLink_1(BMessage *po_Message)
{
	/* check message */	
	{
		ASSERT(po_Message);
		int32 iMenuSelecting=-1;
		ASSERT(B_OK==po_Message->FindInt32("menu",&iMenuSelecting));
		if(iMenuSelecting!=0){
			Action_MakeLink_2(po_Message);			
			return;
		}
	}
	/*========= start action =========*/
	/* prepare vars */
	BF_NodeCollection	*ploNode = Nodes_GetSelecting();
	ploNode->SetSelfPath(new BF_Path(poFriend->oPath));
	BRect 				oRect;	
	BF_GUI_Dialog 		*poDialog=NULL;
	BF_GUI_ViewProgress *poStatus=NULL;
	bool				*pbSemaphor=new bool;	
	*pbSemaphor = false;
	/*===== make  status_dialog ===*/	
	{		
		/* prepare message for dialog */	
		BMessage oMessage;
		oMessage.AddPointer("bf_semaphor",(void*)pbSemaphor);	
		/* make dialog */
		oRect.Set(0,0,400,120);		
		poDialog = new BF_GUI_Dialog(oRect,"Making links...",
				"progress_dialog",&oMessage,BG_GUI_DIALOG_WINRESIZE_MOVE_CENTER);
		poDialog->MoveToCenter(poWinView);
		/*=== make views for dialog ===*/
		/*== make progress_bar */
		{
			poDialog->LocalBounds(oRect);
			oRect.top+=10;
			oRect.bottom = oRect.top+poSysSetup->oFontToolView.fHeight*2;	
			poStatus = new BF_GUI_ViewProgress(oRect,"progress",
					"make links",B_FOLLOW_NONE,B_WILL_DRAW);
			poStatus->SetLimit(ploNode->CountItems());
			poDialog->AddChild(poStatus);
		}
		/*== make menu ==*/
		{
			/* prepare list for menu */
			BL_List *ploMenu = new BL_List();	
			ploMenu->AddItem(new BF_GUI_ViewMenu_Item("Cancel","cancel"));
			/* make menu */
			poDialog->LocalBounds(oRect);
			oRect.bottom -= 5;
			oRect.top = oRect.bottom-poSysSetup->oFontToolView.fHeight;	
			BView * poMenu = new BF_GUI_ViewHMenu(oRect,"menu",B_FOLLOW_ALL,ploMenu);
			poDialog->AddChild(poMenu);
		}
		// start dialog
		poWinView->AddChild(poDialog);
	}
	/*===== make thread ===*/	
	{
		/* make message for thread */
		BMessage *poMessage = new BMessage(BF_MSG_MAKELINKS_FINISH);
		poMessage->AddPointer("bf_nodelist",(void*)ploNode);
		poMessage->AddPointer("bf_focus",(void*)this);
		poMessage->AddPointer("bf_status",(void*)poStatus);
		poMessage->AddPointer("bf_dialog",(void*)poDialog);		
		poMessage->AddPointer("bf_semaphor",(void*)pbSemaphor);				
		/* init thread */
		thread_id idThread = spawn_thread(BF_GUI_FilePanel_MakeLinkThread,"BeFar:make links",
			B_THREAD_SUSPENDED,(void*)poMessage);	
		/*== start thread ==*/
		if(idThread<=0)	ASSERT("can`t start thread BeFar:make links\n");
		ASSERT(B_OK==resume_thread(idThread));	
	}
}

void
BF_GUI_FilePanel::Action_MakeLink_2(BMessage *po_Message)
{
	/* enable panels */
	BF_GUI_Func_PanelsEnable(true);
	MakeFocus();
}

int32 
BF_GUI_FilePanel_MakeLinkThread(void *data)
{
	/*========== get vars from data ========*/
	ASSERT(data);
	BMessage 			*poMessage = (BMessage*)data;
	BF_NodeCollection	*ploNode;
	bool				*pbSemaphor;
	BView				*poStatus;
	BF_GUI_Dialog		*poDialog;
	BF_GUI_FilePanel	*poFocusPanel;
	/**/
	ASSERT(B_OK==poMessage->FindPointer("bf_nodelist",(void**)&ploNode)   && ploNode);
	ASSERT(B_OK==poMessage->FindPointer("bf_focus",(void**)&poFocusPanel) && poFocusPanel);
	ASSERT(B_OK==poMessage->FindPointer("bf_status",(void**)&poStatus)    && poStatus);
	ASSERT(B_OK==poMessage->FindPointer("bf_dialog",(void**)&poDialog)    && poDialog);
	ASSERT(B_OK==poMessage->FindPointer("bf_semaphor",(void**)&pbSemaphor)&& pbSemaphor);
	ASSERT(ploNode->poPath);
	/*========== prepare messages ========*/
	BMessenger oMessenger(poStatus);
	BMessage   oStepMessage(BF_MSG_PROGRESS_STEP);
	/*========== make links !!! ============*/
	{
		/* prep some vars */
		BF_Node 	*poNode=NULL;
		status_t	uRes=0;		
		BString		sFrom,sTo;
		BF_Path		oPathFrom(poFocusPanel->Path());
		/* cycle on list */
		for(int iNode=0;iNode<ploNode->CountItems();iNode++){
			poNode = ploNode->NodeAt(iNode);
			ASSERT(poNode);
			/* try to make link */
			int32 iCopyIndex=0;
			while(TRUE){
				/* prep names */
				sFrom = oPathFrom.Path();
				sFrom << "/";
				sFrom << poNode->sName;
				sTo = ploNode->poPath->Path();
				sTo += "/";
				sTo << poNode->sName;
				if(iCopyIndex>0){
					sTo << " ";
					sTo << iCopyIndex;
				}
				/* make link */
				uRes = BF_Roster_MakeLink(sFrom,sTo);
				if(B_OK == uRes) break;	else
				if(B_FILE_EXISTS == uRes){
					iCopyIndex++;
					continue;
				}else
					ASSERT(B_OK==uRes,"can`t make link");
			}						
			/*== check for canceling ==*/
			snooze(1000);
			if(*pbSemaphor) break;
			/*== step for progress_bar ==*/
			oMessenger.SendMessage(&oStepMessage);			
		}
	}
	/*==== delete temp_vars==================*/
	{
		delete ploNode;
		free(pbSemaphor);
	}
	/*==== close status_dialog ==============*/
	BF_GUI_Func_CloseDialog(poDialog);
	/*==== send final_message to file_panel =====*/
	{
		BMessenger	oMessenger(poFocusPanel);
		oMessenger.SendMessage(poMessage);
	}
	/*======================================*/
	return 0;
}


/*=====================================================================*/
/* 			 														   */
/*=====================================================================*/
#include <Mime.h>
#include <Node.h>
#include <NodeInfo.h>

bool
BF_GUI_FilePanel::Action_SetMIME(BF_Node *po_Node,BF_Path *po_Path)
{
	ASSERT(po_Node && po_Path);

	BMessage oMessage,oMessage1; 
	uint32 i=0,i1=0;
	char *pc,*pc1;
	BMimeType oMime;
	BL_String	sExt;
	
	i = po_Node->sName.FindLast(".");
	if(i>0){
		po_Node->sName.CopyInto(sExt,i+1,po_Node->sName.Length()-i-1);
		
		if(B_OK!=BMimeType::GetInstalledTypes(&oMessage)) return false;
		i = 0;	
		while(true){
			if(oMessage.FindString("types", i++, (const char**)&pc) != B_OK) break; 
			//printf("type=%s\n",pc);	
		
			if(B_OK!=oMime.SetTo(pc)) continue;
			
			if(oMime.GetFileExtensions(&oMessage1) != B_OK) continue;
			
			i1 = 0;			
			while(true){
				if(oMessage1.FindString("extensions", i1++, (const char**)&pc1) != B_OK) break; 
				//sprintf("> Extension:  %s \n", pc1);
				if(sExt==pc1){
					/* found req ext */
					printf("> Type=%s\n",pc);	
					printf("> Extension:  %s \n", pc1);
					/* make node */
					BL_String	s(po_Path->Path());
					s<<"/";
					s<<po_Node->sName;
					BNode  	oNode(s.String());
					BNodeInfo	oNodeInfo(&oNode);
					oNodeInfo.SetType(pc);
					return true;
				}
			}				
		}				
	};
	return false;
}
