#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <File.h>
#include <fs_attr.h>
#include "BF_Roster.h"
#include "BF_Msg.h"
#include "BF_GUI_Func.h"
#include "BF_GUI_Tools.h"
#include "BF_GUI_FilePanel.h"
#include "BF_GUI_KeysMenu.h"
#include "BF_GUI_Viewer.h"


int32 BF_GUI_FilePanel_CopyThread(void *data);


void
BF_GUI_FilePanel::Action_CopyFiles_0()
{
	/* disable panels */
	BF_GUI_Func_PanelsEnable(false);
	/* make message for dialog */
	BMessage oMessage(BF_MSG_FILEPANEL_COPY_1);
	oMessage.AddPointer("bf_focus",this);
	/* make dialog */	
	float fWidth = poWinView->Bounds().Width();
	if(fWidth<400) fWidth-=40;else fWidth=400;
	BF_GUI_Dialog *poDialog = new BF_GUI_Dialog(BRect(30,30,fWidth,120),
		 "Copy file(s) to ","dialog",&oMessage,BG_GUI_DIALOG_WINRESIZE_MOVE_CENTER);
	poDialog->MoveToCenter( poWinView );	
	/* insert views */
	BRect oRect;
	/* insert text */
	poDialog->LocalBounds(oRect);
	/*oRect.top+=10;
	oRect.bottom = oRect.top+poSysSetup->oFontToolView.fHeight*2+4;
	poDialog->AddChild(new BF_GUI_ViewText(oRect,"text","Copy files(s)?",
			B_FOLLOW_NONE,B_WILL_DRAW));*/
	/* insert edit_view */
	poDialog->LocalBounds(oRect);	
	//oRect.top = oRect.bottom+5;
	oRect.bottom = oRect.top+poSysSetup->oFontToolView.fHeight;
	BF_GUI_ViewEdit *poEdit = new BF_GUI_ViewEdit(oRect,"edit",
					poFriend->oPath.Path(),
					B_FOLLOW_LEFT_RIGHT|B_FOLLOW_TOP,B_NAVIGABLE);
	poDialog->AddChild(poEdit);
	/* finish */
	poWinView->AddChild( poDialog );		
}

void
BF_GUI_FilePanel::Action_CopyFiles_1(BMessage *po_Message,bool b_DeleteAfterCopy)
{
	/* check messahe */
	ASSERT(po_Message);
	bool bOk=FALSE;
	ASSERT(B_OK==po_Message->FindBool(BF_GUI_DIALOG_MESSAGE_DATA_OK,&bOk));
	if(!bOk){
		Action_CopyFiles_2(po_Message);
		return;
	}
	/* load childs */
	BF_NodeCollection *ploSelNode = Nodes_GetSelecting();	
	ASSERT(ploSelNode);
	/* prepare new path */		
	char *pcPath=NULL;	
	{
		ASSERT(B_OK==po_Message->FindString("edit",(const char**)&pcPath) && pcPath);
		if(oPath.Compare(pcPath))
		{			
			Action_CopyFiles_2(po_Message);
			return;
		}
	}
	/* prepare new_path */
	BF_Path * poNewPath = new BF_Path(pcPath);
	/* prepare message for dialog */
	BMessage oMessageForDialog(BF_MSG_FILEPANEL_COPY_FINISHED);
	oMessageForDialog.AddPointer("bf_focus",(void*)this);	
	// make status_dialog //
	BRect oRect(0,0,400,220);
	BF_GUI_Dialog * poPanel = new BF_GUI_Dialog(oRect,b_DeleteAfterCopy?"Moving...":"Copying...",
		"progress_dialog",&oMessageForDialog,BG_GUI_DIALOG_WINRESIZE_MOVE_CENTER);
	poPanel->MoveToCenter(poWinView);
	
	BF_GUI_ViewProgress *poTotalCountStatus,*poTotalSizeStatus,*poOneStatus;
	// make total_count progress //	
	{
		poPanel->LocalBounds(oRect);
		oRect.top+=10;
		oRect.bottom = oRect.top+poSysSetup->oFontToolView.fHeight*2;	
		poTotalCountStatus = new BF_GUI_ViewProgress(
			oRect,"totalcount_progress",b_DeleteAfterCopy?"total movied files":"total copyed files",B_FOLLOW_NONE,B_WILL_DRAW|B_PULSE_NEEDED);
		poTotalCountStatus->SetLimit(ploSelNode->CountAll(true));
		poPanel->AddChild(poTotalCountStatus);		
	}
	// make total_size progress //	
	{	
		oRect.top = oRect.bottom + 5;
		oRect.bottom = oRect.top+poSysSetup->oFontToolView.fHeight*2;	
		poTotalSizeStatus = new BF_GUI_ViewProgress(
			oRect,"totalsize_progress",b_DeleteAfterCopy?"total movied bytes":"total copyed bytes",B_FOLLOW_NONE,B_WILL_DRAW|B_PULSE_NEEDED);
		poPanel->AddChild(poTotalSizeStatus);		
	}	
	// make icon for current file //
	{
		oRect.top = oRect.bottom + 9;
		oRect.bottom = oRect.top+16;	
		BF_GUI_FilePanel_ActNodeIcon *poFileIcon= new BF_GUI_FilePanel_ActNodeIcon(
			oRect,"icon",B_FOLLOW_NONE,B_WILL_DRAW);
		poPanel->AddChild(poFileIcon);				
	}	
	// make progressbar for one file //	
	{	
		oRect.top = oRect.bottom + 3;
		oRect.bottom = oRect.top+poSysSetup->oFontToolView.fHeight*2;	
		poOneStatus = new BF_GUI_ViewProgress(
			oRect,"one_progress",b_DeleteAfterCopy?"movied bytes":"copyed bytes",B_FOLLOW_NONE,B_WILL_DRAW|B_PULSE_NEEDED);
		poOneStatus->SetLimit(0);
		poPanel->AddChild(poOneStatus);				
	}
	/* make menu */
	BL_List *ploMenu = new BL_List();	
	ploMenu->AddItem(new BF_GUI_ViewMenu_Item("Pause","pause"));
	ploMenu->AddItem(new BF_GUI_ViewMenu_Item("Cancel","cancel"));
	//
	poPanel->LocalBounds(oRect);
	oRect.bottom -= 5;
	oRect.top = oRect.bottom-poSysSetup->oFontToolView.fHeight;
	//
	BView * poMenu = new BF_GUI_ViewHMenu(oRect,"menu",	B_FOLLOW_ALL,ploMenu);
	poPanel->AddChild(poMenu);
	/* start dialog */
	poWinView->AddChild(poPanel);
	poMenu->MakeFocus();
	///
	BMessage *poMsgForThread = new BMessage(BF_MSG_FILEPANEL_COPY_FINISHED);
	poMsgForThread->AddPointer("bf_nodelist",(void*)ploSelNode);
	poMsgForThread->AddPointer("bf_focus",(void*)this);
	poMsgForThread->AddPointer("bf_dialog",(void*)poPanel);
	poMsgForThread->AddPointer("bf_poPath",(void*)poNewPath);	
	poMsgForThread->AddBool("bf_Delete",b_DeleteAfterCopy);		
	thread_id idThreadCopy = spawn_thread(BF_GUI_FilePanel_CopyThread,"BeFar:copying",
		B_THREAD_SUSPENDED,(void*)poMsgForThread);	
	if(idThreadCopy<=0)	ASSERT("can`t start thread BeFar:copying\n");	
	ASSERT(B_OK==resume_thread(idThreadCopy));		
	set_thread_priority(idThreadCopy,B_NORMAL_PRIORITY);
	//	
}

void
BF_GUI_FilePanel::Action_CopyFiles_2(BMessage *po_Message)
{
	BF_Path *poNewPath = NULL;
	if(B_OK==po_Message->FindPointer("bf_poPath",(void**)&poNewPath) && poNewPath){
		delete poNewPath;	
	}		
	//	
	BF_GUI_Func_PanelsEnable(true);
	MakeFocus();
}

/* global vars for copy */
int64		iBuffer=16384;
char		cBuffer[16385];
#define		CONTROL_TOTALCOUNT_COUNT	0
#define		CONTROL_TOTALCOUNT_INDEX	1
#define		CONTROL_TOTALSIZE_COUNT		2
#define		CONTROL_TOTALSIZE_INDEX		3
#define		CONTROL_ONESIZE_COUNT		4
#define		CONTROL_ONESIZE_INDEX		5
#define		CONTROL_COUNT				6
#define		CONTROL_MENU_PAUSE			7
#define		CONTROL_MENU_CANCEL			8
#define		CONTROL_END					9
/* handle pressing "Pause" */
bool BF_GUI_FilePanel_CopyThread_Node_HandleMenu(int64		*pai_Control)
{
	ASSERT(pai_Control);
	if(1==pai_Control[CONTROL_MENU_CANCEL]){
		pai_Control[CONTROL_MENU_CANCEL] =  0;
		return true;
	}
	if(1!=pai_Control[CONTROL_MENU_PAUSE]) return false;
	/* */
	pai_Control[CONTROL_MENU_PAUSE] = 0;
	while(pai_Control[CONTROL_MENU_PAUSE]==0 && pai_Control[CONTROL_MENU_CANCEL]==0){
		snooze(100);
	}
	pai_Control[CONTROL_MENU_PAUSE] = 0;
	if(1==pai_Control[CONTROL_MENU_CANCEL]){
		pai_Control[CONTROL_MENU_CANCEL] =  0;
		return true;
	}
	return false;
}

bool
BF_GUI_FilePanel_CopyThread_Node(
	BF_NodeCollection *plo_Node,
	BString		& s,
	BString		& s1,
	int64		*pai_Control,
	BString		& s_NewPath,
	bool		& b_DeleteAfterCopy,
	BF_GUI_FilePanel_ActNodeIcon	*po_Icon
)
{
	BF_Node *poNode;
	const char	*pcNewName;
	status_t uRes;
	BString	sNewName;
	
	
	for(int i=0;i<plo_Node->CountItems();i++){
		poNode = (BF_Node*)plo_Node->ItemAt(i);
		poWin->Lock();	
		po_Icon->SetNode(poNode);
		poWin->Unlock();	
		ASSERT(plo_Node->poPath);		
		/* convert name for mask */
		if(poNode->ConvertNameByMask(s_NewPath,sNewName)) pcNewName = sNewName.String();
		else pcNewName = poNode->sName.String();
		/* make new link */		
		if(poNode->bLink){
			/* set one_progress */
			pai_Control[CONTROL_ONESIZE_COUNT]=(int64)0;
			pai_Control[CONTROL_ONESIZE_INDEX]=0;
			////o_MessageLimit.ReplaceInt64("bf_iLimit",(int64)0);
			////o_OneMessenger.SendMessage(&o_MessageLimit);
			/* make link */
			s=plo_Node->poPath->Path();
			s<<"/";
			s<<poNode->sName;
			s1=s_NewPath;
			s1<<"/";
			s1<<pcNewName;
			uRes = BF_Roster_MakeLink(s,s1);
			if(B_OK!=uRes){
				BL_List *ploMenuItem = new BL_List();
				ploMenuItem->AddItem(new BF_GUI_ViewMenu_Item("ignore",""));
				ploMenuItem->AddItem(new BF_GUI_ViewMenu_Item("cancel",""));
				BF_GUI_Func_EnableDialog("dialog",false);	
				int32 iMenuResult = BF_Dialog_Alert("Error","can`t make link",ploMenuItem);
				BF_GUI_Func_EnableDialog("dialog",true);
				if(iMenuResult!=0) return false;
			}
		}else
		/* make new dir */
		if(BF_NODE_TYPE_DIR==poNode->iType){
			/* set one_progress */
			pai_Control[CONTROL_ONESIZE_COUNT]=(int64)0;
			pai_Control[CONTROL_ONESIZE_INDEX]=0;
			/////o_MessageLimit.ReplaceInt64("bf_iLimit",(int64)0);
			////o_OneMessenger.SendMessage(&o_MessageLimit);
			/* make new dir */
			s=s_NewPath;
			s<<"/";
			s<<pcNewName;
			BF_Roster_MakeDir(s.String());			
			BString sNewPath(s);
			/* copy childs */
			if(!BF_GUI_FilePanel_CopyThread_Node(poNode->ploChild,s,s1,
													pai_Control,
													sNewPath,
													b_DeleteAfterCopy,
													po_Icon)
			) return false;						
			if(BF_GUI_FilePanel_CopyThread_Node_HandleMenu(pai_Control)) return false;
		}else					
		/* copy file */
		/*if(BF_NODE_TYPE_FILE==poNode->iType)*/
		{
			// set one_progress
			pai_Control[CONTROL_ONESIZE_COUNT]=(int64)poNode->iSize;
			pai_Control[CONTROL_ONESIZE_INDEX]=0;
			//o_MessageLimit.ReplaceInt64("bf_iLimit",(int64)poNode->iSize);
			//o_OneMessenger.SendMessage(&o_MessageLimit);
			// open source file
			s=plo_Node->poPath->Path();
			s<<"/";
			s<<poNode->sName;
			BFile oSrcFile(s.String(),B_READ_ONLY);
			if(B_OK==oSrcFile.InitCheck()){				
				// open dest file
				s="";
				if(!strchr(pcNewName,'/')) 
					if(s_NewPath.FindFirst("/")==0)	s<<s_NewPath; else
					  s<<plo_Node->poPath->Path();
				s<<"/";
				s<<pcNewName;
				/*s=s_NewPath;
				s<<pcNewName;*/
				BFile oDestFile(s.String(),B_READ_WRITE | B_CREATE_FILE | B_ERASE_FILE);				
				if(B_OK!=oDestFile.InitCheck()){
					s1="Can`t create file '";
					s1<<s;
					s1<<"'";					
					BF_GUI_Func_EnableDialog("dialog",false);						
					BF_Dialog_Alert("Error",s1.String());
					BF_GUI_Func_EnableDialog("dialog",true);
				}else{
					//oDestFile.Unset();
					//oDestFile.SetTo(s.String(),
					/// copy data
					int64 	iStart=0,iCount;					
					while(iStart<poNode->iSize){
						// calc buffer_size
						iCount = iBuffer;
						if((iStart+iCount)>poNode->iSize)	iCount = poNode->iSize-iStart;
						// read
						oSrcFile.Read((void*)cBuffer,iCount);
						// write
						oDestFile.Write((void*)cBuffer,iCount);												
						// step one_progress
						pai_Control[CONTROL_ONESIZE_INDEX]+=iCount;
						////o_MessageStep.ReplaceInt64("bf_iDelta",iCount);
						////o_OneMessenger.SendMessage(&o_MessageStep);
						// step total_size_progress
						pai_Control[CONTROL_TOTALSIZE_INDEX]+=iCount;
						////o_MessageStep.ReplaceInt64("bf_iDelta",iCount);
						////o_TotalSizeMessenger.SendMessage(&o_MessageStep);						
						// next block
						iStart+=iCount;						
						// check cancel
						if(BF_GUI_FilePanel_CopyThread_Node_HandleMenu(pai_Control)) return false;						
						//snooze(1000);	
					}			
					/* copy atribytes */
					{
						char 		pcName[B_ATTR_NAME_LENGTH];
						attr_info	uAttrInfo;
						uint32		iBufMaxSize=255;
						char		*pcBuf = (char*)malloc(iBufMaxSize);
						oSrcFile.RewindAttrs();
						//
						while(B_OK==oSrcFile.GetNextAttrName(pcName)){
							if(B_OK==oSrcFile.GetAttrInfo(pcName,&uAttrInfo)){
								/* check buffer size  */
								if(uAttrInfo.size>iBufMaxSize){
									delete pcBuf;
									iBufMaxSize = uAttrInfo.size;
									pcBuf = (char*)malloc(iBufMaxSize);									
								}
								/* read attr */
								oSrcFile.ReadAttr(pcName,uAttrInfo.type,0,
									(void*)pcBuf,uAttrInfo.size);
								/* write attr */
								oDestFile.WriteAttr(pcName,uAttrInfo.type,
										0,(void*)pcBuf,uAttrInfo.size);
							}
						}						
						delete pcBuf;
					}/* end of atributes */					
				} /* end of work with oDestFile */
				oDestFile.Unset();				
			}
		} /* end of file_node */				
		if(b_DeleteAfterCopy){
			BF_Roster_RemoveNode(*plo_Node->poPath,*poNode);
		}
		/* step total_count_progress */		
		pai_Control[CONTROL_TOTALCOUNT_INDEX]+=1;
		////o_MessageStep.ReplaceInt64("bf_iDelta",1);
		////o_TotalCountMessenger.SendMessage(&o_MessageStep);		
		/* check break_event */
		if(BF_GUI_FilePanel_CopyThread_Node_HandleMenu(pai_Control)) return false;
		//snooze(100);					
	}				
	return true;
}

int32 BF_GUI_FilePanel_CopyThread(void *data)
{
	//
	ASSERT(data);
	//
	BMessage *poMessage = (BMessage*)data;
	/* get nodes */
	BF_NodeCollection *ploReqList=NULL;
	ASSERT(B_OK==poMessage->FindPointer("bf_nodelist",(void**)&ploReqList) && ploReqList);	
	/* get others */
	BF_Path	*poNewPath;
	bool 	bDeleteAfterCopy;
	ASSERT(B_OK==poMessage->FindPointer("bf_poPath",(void**)&poNewPath) && poNewPath!=NULL);		
	ASSERT(B_OK==poMessage->FindBool("bf_Delete",(bool*)&bDeleteAfterCopy));			
	/* */
	bool bRunCycle = true;
	/* check for copy one file into new name */
	{
		BString s(poNewPath->Path());
		if(s.FindFirst("/")<0 && s.FindFirst("*")<0 && s.FindFirst("?")<0
			&& ploReqList->CountItems()>1)
		{
			s="I can`t copy ";
			s<<(int32)ploReqList->CountItems();
			s<<" files in one file";
			BF_GUI_Func_EnableDialog("dialog",false);						
			BF_Dialog_Alert("Error",s.String());
			BF_GUI_Func_EnableDialog("dialog",true);
			bRunCycle = false;
		}
	}
	/* make progress_control_vars */
	int64 	aiControl[CONTROL_END];
	for(int i=0;i<CONTROL_COUNT;i++) aiControl[i]=0;	
	/*------- start cycle --------*/		
	if(bRunCycle){
		poWin->Lock();
		BF_GUI_ViewProgress *poTotalCountProgress = (BF_GUI_ViewProgress*)poWinView->FindView("totalcount_progress");
		BF_GUI_ViewProgress *poTotalSizeProgress = (BF_GUI_ViewProgress*)poWinView->FindView("totalsize_progress");	
		BF_GUI_ViewProgress *poOneProgress = (BF_GUI_ViewProgress*)poWinView->FindView("one_progress");
		BF_GUI_ViewMenu *poMenu = (BF_GUI_ViewMenu*)poWinView->FindView("menu");		
		BF_GUI_FilePanel_ActNodeIcon	*poIcon = (BF_GUI_FilePanel_ActNodeIcon*)poWinView->FindView("icon");
		ASSERT(poIcon);
		ASSERT(poTotalCountProgress);
		ASSERT(poTotalSizeProgress);
		ASSERT(poOneProgress);
		poWin->Unlock();
		
	
		/* start copy files */
		{			
			/* set progress_controls */
			poTotalCountProgress->SetControls(&aiControl[CONTROL_TOTALCOUNT_COUNT],&aiControl[CONTROL_TOTALCOUNT_INDEX]);
			poTotalSizeProgress->SetControls(&aiControl[CONTROL_TOTALSIZE_COUNT],&aiControl[CONTROL_TOTALSIZE_INDEX]);
			poOneProgress->SetControls(&aiControl[CONTROL_ONESIZE_COUNT],&aiControl[CONTROL_ONESIZE_INDEX]);				
			/* set control_var for menu_item "Pause" */
			aiControl[CONTROL_MENU_PAUSE]=-1;
			poMenu->SetControlForItem(0,&aiControl[CONTROL_MENU_PAUSE]);
			/* set control_var for menu_item "Cancel" */
			aiControl[CONTROL_MENU_CANCEL]=-1;
			poMenu->SetControlForItem(1,&aiControl[CONTROL_MENU_CANCEL]);
			/* make self copy of all nodes */		
			ploReqList->MakeSelfNodes();
			/* load nodes */		
			ploReqList->LoadChilds();
			/* set limits */
			aiControl[CONTROL_TOTALCOUNT_COUNT]=(int64)ploReqList->CountAll(true);
			aiControl[CONTROL_TOTALSIZE_COUNT]=(int64)ploReqList->SizeAll(true);		
			/* make other vars */
			BString		s,s1,sNewPath(poNewPath->Path());		
			//
			BF_GUI_FilePanel_CopyThread_Node(ploReqList,s,s1,
				aiControl,
				sNewPath,
				bDeleteAfterCopy,
				poIcon
			);
			/* clear control_var for menu_item "Pause" */
			poMenu->SetControlForItem(0,NULL);
		}
	}
	/*-------- end of cycle ---------*/	
	// send final messages //
	{
		/* send message to progress_dialog about closed */
		{
			BView *poView=NULL;						
			ASSERT(B_OK==poMessage->FindPointer("bf_dialog",(void**)&poView) && poView);
			BMessenger	oMessenger(poView);
			BMessage 	oMessage(BF_MSG_DIALOG_CLOSE_NOW);
			oMessenger.SendMessage(&oMessage);
		}
		poWin->Lock();
		BF_GUI_ViewProgress *poTotalCountProgress = (BF_GUI_ViewProgress*)poWinView->FindView("totalcount_progress");
		BF_GUI_ViewProgress *poTotalSizeProgress = (BF_GUI_ViewProgress*)poWinView->FindView("totalsize_progress");	
		BF_GUI_ViewProgress *poOneProgress = (BF_GUI_ViewProgress*)poWinView->FindView("one_progress");
		BF_GUI_ViewMenu *poMenu = (BF_GUI_ViewMenu*)poWinView->FindView("menu");
		
		if(poTotalCountProgress) 	poTotalCountProgress->SetControls(NULL,NULL);
		if(poTotalSizeProgress) 	poTotalSizeProgress->SetControls(NULL,NULL);
		if(poOneProgress) 			poOneProgress->SetControls(NULL,NULL);		
		if(poMenu)					poMenu->SetControlForItem(0,NULL);
		if(poMenu)					poMenu->SetControlForItem(1,NULL);		
		
		poWin->Unlock();		
		// send message to panel about finishing //
		{		
			BView *poView=NULL;
			ASSERT(B_OK==poMessage->FindPointer("bf_focus",(void**)&poView) && poView);
			BMessenger	oMessenger(poView);
			oMessenger.SendMessage(poMessage);
		}
	}		
	delete ploReqList;
	//
	return 0;
}

