#include <stdio.h>
#include <stdlib.h>

#include <File.h>
#include <fs_attr.h>

#include "BF_Roster.h"
#include "BF_Msg.h"
#include "BF_GUI_Func.h"
#include "BF_GUI_Tools.h"
#include "BF_GUI_FilePanel.h"
#include "BF_GUI_KeysMenu.h"


int32 
BF_GUI_FilePanel_DeleteThread(void *data);

bool
BF_GUI_FilePanel::Action_DeleteFiles_0(BF_FilePanel_RemoveType i_TypeRemove)
{
	/* ask about deleting*/
	if(poSysSetup->iMainStyle & BF_SETUP_MAIN_ASK_DELETE){
		// disable panels //
		BF_GUI_Func_PanelsEnable(false);	
		//
		BMessage oMessage(BF_MSG_DELETE);
		oMessage.AddPointer("bf_focus",(void*)this);
		oMessage.AddInt32("bf_iTypeRemove",(int32)i_TypeRemove);
		//
		BF_GUI_Dialog *poToolView = new BF_GUI_Dialog(BRect(30,30,400,150)
				,"Delete","",&oMessage,BG_GUI_DIALOG_WINRESIZE_MOVE_CENTER);
		poToolView->MoveToCenter(poWinView);
		poWinView->AddChild(poToolView);		
		//
		BRect oRect;
		poToolView->LocalBounds(oRect);
		oRect.bottom-=5;
		oRect.top=oRect.bottom - poSysSetup->oFontToolView.fHeight+2;
		oRect.left+=10;
		oRect.right-=10;		
		BL_List *ploMenu = new BL_List();
		ploMenu->AddItem(new BF_GUI_ViewMenu_Item("Ok","ok"));
		ploMenu->AddItem(new BF_GUI_ViewMenu_Item("Cancel","cancel"));
		//		
		BF_GUI_ViewHMenu *po = new BF_GUI_ViewHMenu(oRect,"menu",B_FOLLOW_BOTTOM,
			ploMenu);
		//
		BString s;
		if(BF_FILEPANEL_REMOVE_TO_TRASH==i_TypeRemove)
			s<<"Move file(s) to trash ?";else	
		if(BF_FILEPANEL_REMOVE_TO_VOID==i_TypeRemove)
			s<<"Delete file(s) ?";
		poToolView->LocalBounds(oRect);
		oRect.top+=10;
		oRect.bottom = oRect.top+poSysSetup->oFontToolView.fHeight*2+4;
		poToolView->AddChild(new BF_GUI_ViewText(oRect,"text",s.String(),
				B_FOLLOW_NONE,B_WILL_DRAW));
		//
		poToolView->AddChild(po);			
		po->MakeFocus();
	}
	return true;
}

void
BF_GUI_FilePanel::Action_DeleteFiles_1(BMessage *po_Message)
{
	/* check messahe */
	ASSERT(po_Message);
	bool bOk=FALSE;
	ASSERT(B_OK==po_Message->FindBool(BF_GUI_DIALOG_MESSAGE_DATA_OK,&bOk));
	if(!bOk){
		//Debug_Alert("!bOk");
		Action_DeleteFiles_2(po_Message);
		return;
	}
	/* check menu_result */
	int32 iMenuResult=-1;
	ASSERT(B_OK==po_Message->FindInt32("menu",&iMenuResult));	
	if( iMenuResult!=0){
		Action_DeleteFiles_2(po_Message);
		return;
	}
	// get type removing
	int32 iTypeRemove=BF_FILEPANEL_REMOVE_TO_TRASH;
	ASSERT(B_OK==po_Message->FindInt32("bf_iTypeRemove",&iTypeRemove));
	// make semaphor 
	bool *pbSemaphor = new bool;
	*pbSemaphor = false;
	// preapre nodes //
	BF_NodeCollection *ploSelNode = Nodes_GetSelecting();	
	ploSelNode->MakeSelfNodes();
	/* prepare message for dialog */
	BMessage oMessage(BF_MSG_DELETE_CANCEL);
	oMessage.AddPointer("bf_focus",(void*)this);	
	oMessage.AddPointer("bf_semaphor",(void*)pbSemaphor);	
	// make status_dialog //
	BRect oRect(0,0,400,120);
	BF_GUI_Dialog * poPanel = new BF_GUI_Dialog(oRect,"Deleting...","progress_dialog",
			&oMessage,BG_GUI_DIALOG_WINRESIZE_MOVE_CENTER);
	poPanel->MoveToCenter(poWinView);
	// make status_view	
	poPanel->LocalBounds(oRect);
	oRect.top+=10;
	oRect.bottom = oRect.top+poSysSetup->oFontToolView.fHeight*2;	
	BF_GUI_ViewProgress *poStatus = new BF_GUI_ViewProgress(oRect,"progress",
		"deleted files",B_FOLLOW_NONE,B_WILL_DRAW);
	poStatus->SetLimit(ploSelNode->CountItems());
	poPanel->AddChild(poStatus);
	//
	BL_List *ploMenu = new BL_List();	
	ploMenu->AddItem(new BF_GUI_ViewMenu_Item("Cancel","cancel"));
	//
	poPanel->LocalBounds(oRect);
	oRect.bottom -= 5;
	oRect.top = oRect.bottom-poSysSetup->oFontToolView.fHeight;
	//
	BView * poMenu = new BF_GUI_ViewHMenu(oRect,"menu",
		B_FOLLOW_ALL,ploMenu);
	poPanel->AddChild(poMenu);
	// start dialog
	poWinView->AddChild(poPanel,poWinView->ChildAt(0));
	poMenu->MakeFocus();
	///
	BMessage *poMessage = new BMessage(BF_MSG_DELETE_FINISH);
	poMessage->AddPointer("bf_nodelist",(void*)ploSelNode);
	poMessage->AddPointer("bf_focus",(void*)this);
	poMessage->AddPointer("bf_dialog",(void*)poPanel);
	poMessage->AddPointer("bf_semaphor",(void*)pbSemaphor);	
	poMessage->AddInt32("bf_iTypeRemove",iTypeRemove);
	thread_id idThreadDeleting = spawn_thread(BF_GUI_FilePanel_DeleteThread,"BeFar:delete",
		B_THREAD_SUSPENDED,(void*)poMessage);	
	if(idThreadDeleting<=0)	ASSERT("can`t start thread BeFar:delete\n");
	ASSERT(B_OK==resume_thread(idThreadDeleting));	
}

void
BF_GUI_FilePanel::Action_DeleteFiles_2(BMessage *po_Message)
{			
	//		
	BF_NodeCollection *ploDoneList=NULL;
	if(B_OK==po_Message->FindPointer("bf_nodelist",(void**)&ploDoneList) && ploDoneList){
		delete ploDoneList;
	}
	//
	BF_GUI_Func_PanelsEnable(true);	
	MakeFocus();
}

#define		CONTROL_COUNT	0
#define		CONTROL_INDEX	1
#define		CONTROL_END		2

bool
BF_GUI_FilePanel_DeleteThread_DeleteNode(
	BF_NodeCollection & lo_Node,
	int64			  * pai_Control,
	bool			  * pbSemaphor,
	int				    i_TypeRemove,
	BString			  & s_TrashPath,
	BString			  & s
){
	BF_Node  	*poNode;
	status_t	uRes;
	for(int i=0;i<lo_Node.CountItems();i++){
		poNode = (BF_Node*)lo_Node.ItemAt(i);
		ASSERT(lo_Node.poPath);
		printf("BF_GUI_FilePanel_DeleteThread_DeleteNode step {%s} \n",poNode->sName.String());
		if(poNode->ploChild){
			BF_GUI_FilePanel_DeleteThread_DeleteNode(*poNode->ploChild,
				pai_Control,pbSemaphor,i_TypeRemove,s_TrashPath,s);
		}
		// check, remove file or move it to trash
		if(BF_FILEPANEL_REMOVE_TO_VOID==i_TypeRemove){
			BF_Roster_RemoveNode(*lo_Node.poPath,poNode);
		}else
		if(BF_FILEPANEL_REMOVE_TO_TRASH==i_TypeRemove){			
			int64		iIndex = 1;	
			char		*pcName=NULL;
			while(TRUE){
				uRes = BF_Roster_MoveNode(*lo_Node.poPath,
								poNode,s_TrashPath.String(),pcName);
				if(B_OK==uRes) break;
				/* try to move to new name */
				if(B_FILE_EXISTS==uRes){
					s=poNode->sName;
					s<<" ";
					s<<iIndex++;
					pcName = (char*)s.String();
					continue;
				}
				/* ups....some error */
				s="unknown error";
				if(B_BUSY==uRes){
					s<<"file is busy";
				}else
					{};
				BF_GUI_Func_EnableDialog("dialog",false);	
				BF_Dialog_Alert("Error",s.String());
				BF_GUI_Func_EnableDialog("dialog",true);	
			}
		}
		//
		snooze(100);
		if(*pbSemaphor) break;
		pai_Control[CONTROL_INDEX]+=1;
		//
	}
	return true;
}

int32 
BF_GUI_FilePanel_DeleteThread(void *data)
{
	printf("BF_GUI_FilePanel_DeleteThread starting \n");
	ASSERT(data);
	//
	BMessage *poMessage = (BMessage*)data;
	/* get type removing */
	int32 iTypeRemove=BF_FILEPANEL_REMOVE_TO_TRASH;
	ASSERT(B_OK==poMessage->FindInt32("bf_iTypeRemove",&iTypeRemove));
	/* get list */
	BF_NodeCollection *ploReqList=NULL;
	ASSERT(B_OK==poMessage->FindPointer("bf_nodelist",(void**)&ploReqList) && ploReqList);		
	/* make progress_control_vars */
	int64 	aiControl[CONTROL_END];
	for(int i=0;i<CONTROL_END;i++) aiControl[i]=0;	
	aiControl[CONTROL_COUNT] = ploReqList->CountAll(true);
	/* set progress_controls */
	poWin->Lock();
	BF_GUI_ViewProgress *poCountProgress = (BF_GUI_ViewProgress*)poWinView->FindView("progress");	
	ASSERT(poCountProgress);
	poCountProgress->SetControls(&aiControl[CONTROL_COUNT],&aiControl[CONTROL_INDEX]);
	poWin->Unlock();
	/**/
	BF_NodeCollection *ploDoneList = new BF_NodeCollection();
	bool 		*pbSemaphor;
	BString		s,sTrashPath;	
	/* chech path existing */
	ASSERT(ploReqList->poPath);
	/* prepare Trash_path */	
	if(BF_SETUP_MAIN_USE_VOLUME_TRASH & poSysSetup->iMainStyle){		
		ASSERT(ploReqList->poPath->GetVolume(s,false));
		sTrashPath = s;
		if(sTrashPath=="/boot"){
			sTrashPath = poSysSetup->oPathSysTrash.Path();
		}else{
			sTrashPath = s;
			sTrashPath<<"/home/Desktop/Trash";
			if(!BF_Roster_NodeExists(sTrashPath.String())){
				sTrashPath = s;
				sTrashPath<<"/RECYCLED/_BEOS_";
				if(!BF_Roster_NodeExists(sTrashPath.String())){
					if(B_OK!=BF_Roster_MakeDir(sTrashPath.String())){
						s="can`t make Trash_Dir ";
						s<<sTrashPath.String();
						ASSERT(FALSE,s.String());
					}
				}
			}
		}
	}else{
		sTrashPath = poSysSetup->oPathSysTrash.Path();
	}
	/*--------------------*/
	ASSERT(B_OK==poMessage->FindPointer("bf_semaphor",(void**)&pbSemaphor) && pbSemaphor);		
	//
	ASSERT(poSysKeysMenu);
	BView *poProgress = poSysKeysMenu->Window()->FindView("progress");
	ASSERT(poProgress);
	// start deleting files //
	{
		// check deleting_type
		if(BF_FILEPANEL_REMOVE_TO_VOID==iTypeRemove){			
			ploReqList->LoadChilds(BF_ROSTER_LOAD_NODE_ALL_REAL|BF_ROSTER_LOAD_NORMAL);
		}
		// cycle deleting //
		BF_GUI_FilePanel_DeleteThread_DeleteNode(*ploReqList,aiControl,
			pbSemaphor,iTypeRemove,sTrashPath,s);
		//
	}
	delete ploReqList;
	delete pbSemaphor;
	// send final message //
	{
		printf("BF_GUI_FilePanel_DeleteThread final \n");
		//
		// send message to progress_dialog about closed //
		{
			BView *poView=NULL;						
			ASSERT(B_OK==poMessage->FindPointer("bf_dialog",(void**)&poView) && poView);
			BMessenger	oMessenger(poView);
			BMessage 	oMessage(BF_MSG_DIALOG_CLOSE_NOW);
			oMessenger.SendMessage(&oMessage);
		}
		/* clear control_vars */
		/*
		bool bFinished=false;
		while(!bFinished){
			bFinished = true;
			for(int i=0;i<CONTROL_END;i++){
				if(aiControl[i]==-1 ) bFinished = false;else
				if(aiControl[i]==-2 ) continue;else
				aiControl[i]=-1;				
			}
		};*/
		poWin->Lock();
		BF_GUI_ViewProgress *poCountProgress = (BF_GUI_ViewProgress*)poWinView->FindView("progress");
		if(poCountProgress)	poCountProgress->SetControls(NULL,NULL);
		poWin->Unlock();
		printf("BF_GUI_FilePanel_DeleteThread send message \n");		
		// send message to panel about finishing //
		{
			BView *poView=NULL;
			ASSERT(B_OK==poMessage->FindPointer("bf_focus",(void**)&poView) && poView);
			BMessenger	oMessenger(poView);
			poMessage->ReplacePointer("bf_nodelist",ploDoneList);
			oMessenger.SendMessage(poMessage);
		}
	}	
	return 0;
}
