#include "stdio.h"

#include "BF_Roster.h"
#include "BF_Msg.h"
#include "BF_GUI_Tools.h"
#include "BF_GUI_KeysMenu.h"

#include "BF_GUI_InfoPanel.h"

#include "BF_Roster.h"



  
BF_GUI_InfoPanel::BF_GUI_InfoPanel(BRect & o_Rect,BF_Panel_Pos	i_WinPosition)
:BF_GUI_Panel(o_Rect,"info",i_WinPosition) 
{
	bNodeReady = false;
	SetHeader("File information");
	oVol.poNode = &oNodeVol;
}


void					
BF_GUI_InfoPanel::DrawPanel(BRect &o_Rect)
{
	BF_GUI_Panel::DrawPanel(o_Rect);
	
	float	fHeight = poSysSetup->oFontNode.fHeight;
	/* draw header */	
	DrawHeader(IsFocus());
	/* draw bottom */	
	DrawBottom("", TRUE);
	//////////////////////////////////////////////////
	if(!bNodeReady) return;
	
	float 		fy = HeaderHeight() + fHeight;
	BPoint 		o,o1,o2;
	BL_String	s,s1;
	BRect		oRect;
	
	
	poRender->SetHighColor(poSysSetup->aColor[BF_COLOR_NODE]);
	poRender->SetLowColor(poSysSetup->aColor[BF_COLOR_BACK]);	
	/* draw icon */	
	if(oNode.poLIcon){
		o.Set(10,fy);
		poRender->SetDrawingMode(B_OP_ALPHA);		
		poRender->DrawBitmap(oNode.poLIcon,o);
		poRender->SetDrawingMode(B_OP_COPY);				
	}	
	/* draw file name */	
	o.Set(50,fy+poSysSetup->oFontToolView.fAscent);
	s="";
	s<<oNode.sName;
	poRender->DrawString(s.String(),o);
	fy += fHeight+5;
	/* draw path */
	o.Set(50,fy+poSysSetup->oFontToolView.fAscent);
	s="";
	s<<oPath.Path();
	poRender->DrawString(s.String(),o);
	fy += fHeight+5;	
	/* draw size */
	o.Set(10,fy+poSysSetup->oFontToolView.fAscent);
	s="Size: ";
	s1=oNode.iSize;
	s1.SetDigits();
	s<<s1;
	poRender->DrawString(s.String(),o);
	fy += fHeight+5;	
	/* draw date */
	o.Set(10,fy+poSysSetup->oFontToolView.fAscent);
	s="Date: ";
	char pcBuffer[200]="";
	{
		tm* puTime = localtime(&oNode.uCreateTime);; 
		if(puTime){
			sprintf(pcBuffer,"%i.%i.%i",
				puTime->tm_mday,
				puTime->tm_mon+1,
				puTime->tm_year+1900);				
		}
	}
	s<<pcBuffer;
	poRender->DrawString(s.String(),o);
	fy += fHeight+5;		
	/* draw perms */
	s="Perms : ";
	oNode.PermsTo(s1);
	s<<s1;
	o.Set(10,fy+poSysSetup->oFontToolView.fAscent);
	poRender->DrawString(s.String(),o);
	fy += fHeight+5;
	/* draw mime_type */
	s="Mime : ";
	s<<oNode.sType;
	o.Set(10,fy+poSysSetup->oFontToolView.fAscent);
	poRender->DrawString(s.String(),o);
	fy += fHeight+5;		
	/* draw line */
	oRect = poRender->Bounds();
	o1.x = 5;
	o1.y = fy;
	o2 = o1;
	o2.x =  oRect.Width()-10;	
	poRender->SetHighColor(poSysSetup->aColor[BF_COLOR_FRAME]);
	poRender->StrokeLine(o1,o2);	
	fy += 5;
	/////////////////////// draw curr volume /////////////
	poRender->SetHighColor(poSysSetup->aColor[BF_COLOR_NODE]);
	poRender->SetLowColor(poSysSetup->aColor[BF_COLOR_BACK]);		
	/* draw icon */	
	if(oNodeVol.poLIcon){
		o.Set(10,fy);
		poRender->SetDrawingMode(B_OP_ALPHA);		
		poRender->DrawBitmap(oNodeVol.poLIcon,o);
		poRender->SetDrawingMode(B_OP_COPY);				
	}	
	/* draw file name */	
	o.Set(50,fy+poSysSetup->oFontToolView.fAscent);
	s="";
	s<<oNodeVol.sName;
	poRender->DrawString(s.String(),o);
	fy += fHeight*2+5*2;
	/* */
	o.Set(10,fy+poSysSetup->oFontToolView.fAscent);
	s="Capacity : ";
	s1=oVol.iCapacity;
	s1.SetDigits();
	s<<s1;
	poRender->DrawString(s.String(),o);
	fy += fHeight+5;	
	/* */
	o.Set(10,fy+poSysSetup->oFontToolView.fAscent);
	s="Free bytes : ";
	s1=oVol.iFree;
	s1.SetDigits();
	s<<s1;
	poRender->DrawString(s.String(),o);
	fy += fHeight+5;		
}

void					
BF_GUI_InfoPanel::SetNode(BF_Node *po_Node,BF_Path & o_Path)
{
	if(po_Node){
		ASSERT(po_Node);
		oNode.Set(po_Node);
		oPath.Set(o_Path);
		bNodeReady = true;		
		BF_Roster_ReloadNode(&oPath,&oNode,BF_ROSTER_LOAD_LICON|BF_ROSTER_LOAD_TYPE|BF_ROSTER_LOAD_PERMS);
		//
		/* load vol */
		BL_String sVol;
		oPath.GetVolume(sVol,true);
		oNodeVol.sName = sVol;
		BF_Roster_ReloadNode(NULL,&oNodeVol,BF_ROSTER_LOAD_LICON);
		//
		oVol.LoadInfo();
	}else{
		bNodeReady = false;
	}
	if(Parent()) Invalidate();
}